<?php

namespace Drupal\pagedesigner;

/**
 * Extend Drupal's Twig_Extension class.
 */
class CustomFunctionTwigExtension extends \Twig_Extension {

  /**
   * {@inheritdoc}
   */
  public function getFunctions() {
    return [
      new \Twig_SimpleFunction('custom_function', [$this, 'callFunction']),
    ];
  }

  /**
   * Returns associative array from $string.
   *
   * @param string $function
   *   Funciton to be called.
   *
   * @param string $args
   *   Arguments.
   */
  public function callFunction($function, ...$args) {
    $fn = \Drupal::service('twig')->getFunction($function);

    if ($fn === FALSE) {
      return NULL;
    }

    return $fn->getCallable()(...$args);
  }

}
