<?php

namespace Drupal\pagedesigner;

/**
 *
 */
final class ElementEvents {
  /**
   * Name of the event fired before getting data from a pagedesigner element.
   */
  const GET_BEFORE = 'pagedesigner.getBefore';

  /**
   * Name of the event fired before getting data from a pagedesigner element.
   */
  const GET_AFTER = 'pagedesigner.getAfter';

  /**
   * Name of the event fired before patching a pagedesigner element.
   */
  const PATCH_BEFORE = 'pagedesigner.patchBefore';

  /**
   * Name of the event fired after patching a pagedesigner element.
   */
  const PATCH_AFTER = 'pagedesigner.patchAfter';

  /**
   * Name of the event fired before adjusting the attachment collection in a handler.
   */
  const COLLECTATTACHMENTS_BEFORE = 'pagedesigner.collectAttachmentsBefore';

  /**
   * Name of the event fired after adjusting the attachment collection in a handler.
   */
  const COLLECTATTACHMENTS_AFTER = 'pagedesigner.collectAttachmentsAfter';

  /**
   * Name of the event fired before collecting the patterns in a handler.
   */
  const COLLECTPATTERNS_BEFORE = 'pagedesigner.collectPatternsBefore';

  /**
   * Name of the event fired after collecting the patterns in a handler.
   */
  const COLLECTPATTERNS_AFTER = 'pagedesigner.collectPatternsAfter';

  /**
   * Name of the event fired before adapting the pattern list in a handler.
   */
  const ADAPTPATTERNS_BEFORE = 'pagedesigner.adaptPatternsBefore';

  /**
   * Name of the event fired after adapting the pattern list in a handler.
   */
  const ADAPTPATTERNS_AFTER = 'pagedesigner.adaptPatternsAfter';

  /**
   * Name of the event fired before preparing a field of a pattern.
   */
  const PREPARE_BEFORE = 'pagedesigner.prepareBefore';

  /**
   * Name of the event fired after preparing a field of a pattern.
   */
  const PREPARE_AFTER = 'pagedesigner.prepareAfter';

  /**
   * Name of the event fired before getting the content from a pagedesigner element.
   */
  const GETCONTENT_BEFORE = 'pagedesigner.getContentBefore';

  /**
   * Name of the event fired after getting the content from a pagedesigner element.
   */
  const GETCONTENT_AFTER = 'pagedesigner.getContentAfter';

  /**
   * Name of the event fired before creating a pagedesigner element.
   */
  const GENERATE_BEFORE = 'pagedesigner.generateBefore';

  /**
   * Name of the event fired after creating a pagedesigner element.
   */
  const GENERATE_AFTER = 'pagedesigner.generateAfter';

  /**
   * Name of the event fired before copying a pagedesigner element.
   */
  const COPY_BEFORE = 'pagedesigner.copyBefore';

  /**
   * Name of the event fired after copying a pagedesigner element.
   */
  const COPY_AFTER = 'pagedesigner.copyAfter';

  /**
   * Name of the event fired before deleting a pagedesigner element.
   */
  const DELETE_BEFORE = 'pagedesigner.deleteBefore';

  /**
   * Name of the event fired after deleting a pagedesigner element.
   */
  const DELETE_AFTER = 'pagedesigner.deleteAfter';

  /**
   * Name of the event fired before restoring a pagedesigner element.
   */
  const RESTORE_BEFORE = 'pagedesigner.deleteBefore';

  /**
   * Name of the event fired after restoring a pagedesigner element.
   */
  const RESTORE_AFTER = 'pagedesigner.deleteAfter';

  /**
   * Name of the event fired before rendering a pagedesigner element.
   */
  const RENDER_BEFORE = 'pagedesigner.renderBefore';

  /**
   * Name of the event fired after rendering a pagedesigner element.
   */
  const RENDER_AFTER = 'pagedesigner.renderAfter';

  /**
   * Name of the event fired before rendering a pagedesigner element for edit.
   */
  const RENDERFOREDIT_BEFORE = 'pagedesigner.renderForEditBefore';

  /**
   * Name of the event fired after rendering a pagedesigner element for edit.
   */
  const RENDERFOREDIT_AFTER = 'pagedesigner.renderForEditAfter';

  /**
   * Name of the event fired before rendering a pagedesigner element for public.
   */
  const RENDERFORPUBLIC_BEFORE = 'pagedesigner.renderForPublicBefore';

  /**
   * Name of the event fired after rendering a pagedesigner element for public.
   */
  const RENDERFORPUBLIC_AFTER = 'pagedesigner.renderForPublicAfter';

  /**
   * Name of the event fired before serializing the data from a pagedesigner element.
   */
  const SERIALIZE_BEFORE = 'pagedesigner.serializeBefore';

  /**
   * Name of the event fired after serializing the data from a pagedesigner element.
   */
  const SERIALIZE_AFTER = 'pagedesigner.serializeAfter';

  /**
   * Name of the event fired before describing the structure from a pagedesigner element.
   */
  const DESCRIBE_BEFORE = 'pagedesigner.describeBefore';

  /**
   * Name of the event fired after describing the structure from a pagedesigner element.
   */
  const DESCRIBE_AFTER = 'pagedesigner.describeAfter';

  /**
   * Name of the event fired before publishing a pagedesigner element.
   */
  const PUBLISH_BEFORE = 'pagedesigner.publishBefore';

  /**
   * Name of the event fired after publishing a pagedesigner element.
   */
  const PUBLISH_AFTER = 'pagedesigner.publishAfter';

  /**
   * Name of the event fired before unpublishing a pagedesigner element.
   */
  const UNPUBLISH_BEFORE = 'pagedesigner.unpublishBefore';

  /**
   * Name of the event fired after unpublishing a pagedesigner element.
   */
  const UNPUBLISH_AFTER = 'pagedesigner.unpublishAfter';

}
