<?php

namespace Drupal\pagedesigner;

use Drupal\Core\DependencyInjection\ContainerInjectionInterface;
use Drupal\Core\StringTranslation\StringTranslationTrait;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 *
 */
class PagedesignerPatternPermissions implements ContainerInjectionInterface {

  use StringTranslationTrait;

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static();
  }

  /**
   * Get permissions for Taxonomy Views Integrator.
   *
   * @return array
   *   Permissions array.
   */
  public function permissions() {
    $permissions = [];

    $patterns = \Drupal::service('plugin.manager.ui_patterns')->getDefinitions();

    ksort($patterns);
    foreach ($patterns as $pattern_id => $pattern) {
      $permissions += [
        'use pattern ' . $pattern_id => [
          'title' => $this->t('Use pattern %pattern in Pagedesigner', ['%pattern' => t($pattern->getLabel())]),
        ],
      ];

    }
    return $permissions;
  }

}
